#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <lgba.h>
#include <string.h>
#include <strfunc.h>

char *oc=NULL;
char *t=NULL;
char *t4=NULL;
char *utv=NULL;
char *cln=NULL;

int dofunc(int);

int main(int ac, char **av) {
	int ca;
	slist *sl;

	if(ac == 1) {
		fprintf(stderr,
"LGBA Resource decreaser (c) Lev Walkin <vlm@spelio.net.ru> 2000

Usage: %s [-n <lgba_node>] {<objectclass>|<ldapfilter>} <timeleft_attr> <time4period_attr> [<timemax_attr> [<clean_attr>]]
", *av);
		exit(2);
	};

	setgid(getegid());

	if(lgba_init(NULL) || lgba_open()) {
		lgba_perror("LGBA Init error");
		exit(2);
	};

	if(lgba_setuser("root")) {
		lgba_perror("Set user(\"root\") failed.");
		exit(2);
	};

	ca=1;
	if(*av[1] == '-') {
		if(ac < 3 || !eq(av[1], "-n")) {
			fprintf(stderr, "Error: [-n <lgba_node>] required\n");
			exit(2);
		};
		if(lgba_chnode(av[2])) {
			lgba_close();
			fprintf(stderr, "Error: Failed to change node...\n");
			exit(2);
		};
		fprintf(stderr, "LGBA Node changed to '%s'.\n", av[2]);
		ca=3;
	};

	if(ac <= ca) {
		fprintf(stderr, "Error: mandatory parameter missing.\n");
		exit(2);
	};

	sl=sinit(NULL);
	sadd(sl, "object");
	sadd(sl, "objectclass");

	oc=av[ca];

	if(!strchr(oc, '='))
	sprintf(oc=(char *)malloc(strlen(oc) +30), "(objectclass=%s)", av[ca]);

	if(ac > ++ca) t=av[ca]; sadd(sl, t);
	if(ac > ++ca) t4=av[ca]; sadd(sl, t4);
	if(ac > ++ca) utv=av[ca]; sadd(sl, utv);
	if(ac > ++ca) cln=av[ca]; sadd(sl, cln);

	if(!t || !strlen(t) || !t4 || !strlen(t4) || (utv && !strlen(utv))) {
		fprintf(stderr, "Error: Parameter missing or empty.\n");
		exit(2);
	};

	lgba_search(NULL, oc, sarray(sl, 0), NULL, NULL, NULL, dofunc, 0);

	lgba_close();

	return 0;
};

int dofunc(int z) {
	register char *s;
	register int t_, t4_, utv_;
	static char fornum[64];

	s=getattr(t);
	if(!*s) return 0;

	t_=atoi(s);
	t4_=atoi(getattr(t4));
	if(!t4_) return 0;

	format("User ${object}, ${timeleft}+${time4period}\n", 1);
	if(utv) {
		if((utv_=atoi(getattr(utv)))) {
		  if(t_ + t4_ > utv_) {
			sprintf(fornum, "=%d", utv_);
			goto ex;
		  };
		} else {
			sprintf(fornum, "=%d", t4_);
			goto ex;
		};
	};

	sprintf(fornum, "%+d", t4_);

ex:
	setattr(t, fornum);
	setattr(cln, "=0");

	return 0;
};

