#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/file.h>
#include <time.h>
#include <locale.h>
#include <unistd.h>
#include "tac_plus.h"
#include "utmp.h"
#include <cost.h>
#include <strfunc.h>

int ufd;
int slots=0;
off_t size=0;
struct utmp *ufile;

char *online(time_t);
void copy();

int htmlmode=0;

#ifndef UTMP_FILE
#error PLEASE define UTMP_FILE for use with xw!
#endif

slist *priv;

int main() {
	struct stat sb;
	int i;
	int c;
	struct utmp *up;
	char *FMT="%-15s%-15s%-15s%-15s%-15d\n";

	setlocale(LC_ALL, "");

	if(getenv("SCRIPT_NAME")) {
		htmlmode++;
	FMT="<TR BGCOLOR=#ffffd0><TD><B><A HREF=show.cgi?search=%s&object=%s>%s</B></TD><TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%d</TD></TR>\n";
	}

	if(htmlmode) printf("Content-type: text/html\n\n");

	if(lc_init(NULL)) {
		printf("Can't read pricing information");
		exit(2);
	};

	if(cfgread(CONFIG)) {
		if(htmlmode) printf("Can't read config file...");
		exit(2);
	};
	priv=cfgget2("private");

	if(htmlmode)
	printf("<HTML><HEAD><META HTTP-EQUIV=Refresh CONTENT=10><TITLE>Cisco tails</TITLE></HEAD><BODY BGCOLOR=white><H2 ALIGN=CENTER>Cisco tails</H2>");

	if(((ufd=open(UTMP_FILE, O_RDONLY)) == -1) || fstat(ufd, &sb)) {
		if(htmlmode) {
			printf("<B><FONT COLOR=red>Can't open utmp file.</FONT></B>"); copy();
		} else
		fprintf(stderr, "Error: can't open utmp file.\n");
		exit(2);
	};

	if(!(slots=(size=sb.st_size)/sizeof(struct utmp))) {
		if(htmlmode) {
			printf("<B><FONT COLOR=red>UTMP file is empty.</FONT></B>"); copy();
		} else
		fprintf(stderr, "Error: utmp file is empty.\n");
		exit(2);
	};

	up=ufile=(struct utmp *)malloc(slots * sizeof(struct utmp));
	read(ufd, ufile, size);

	c=0;
	for(i=0; i<slots; i++, up++) {
		if(!*up->ut_name || !up->ut_time) continue;
		if(priv && sfind(priv, up->ut_name) != -1) continue;
		c++;
		if(c==1) {
			if(htmlmode)
			printf("<CENTER><TABLE WIDTH=80%% CELLSPACING=0 BGCOLOR=#907060 CELLPADDING=0 BORDER=0><TR><TD><TABLE WIDTH=100%% BGCOLOR=#907060 ALIGN=CENTER BORDER=0 CELLSPACING=1 CELLPADDING=4><TR BGCOLOR=#a0ffe0><TH><FONT COLOR=black>User</TH><TH><FONT COLOR=black>NAS</TH><TH><FONT COLOR=black>Line</TH><TH><FONT COLOR=black>Online</TH><TH>Cost</TH></TR>\n");
			else fprintf(stderr, "%-15s%-15s%-15s%-15s%-15s\n",
			"User", "NAS", "Line", "Online", "Cost");
		}
		if(htmlmode)
		printf(FMT, up->ut_name, up->ut_name, up->ut_name, up->ut_host, up->ut_port, online(up->ut_time), (int)lc_timecost(up->ut_time, (int)difftime(time(NULL), up->ut_time), "online", NULL));
		else
		printf(FMT, up->ut_name, up->ut_host, up->ut_port, online(up->ut_time), (int)lc_timecost(up->ut_time, (int)difftime(time(NULL), up->ut_time), "online", NULL));
	};
	free(ufile);

	if(c) {
		if(htmlmode) printf("</TABLE></TD></TR></TABLE>");
	} else {
		if(htmlmode)
		printf("<CENTER><B>No users online.</B></CENTER>");
		else fprintf(stderr, "No users online.\n");
	}

	if(htmlmode) copy();

	return 0;
};

char *online(time_t con) {
	static char buf[64];
	time_t t;

	t=time(NULL)-con;

	if(t/86400)
		snprintf(buf,sizeof(buf), "%d %02d:%02d", (int)(t/86400), (int)(t%86400)/3600, (int)t%86400%3600/60);
	else if(t/60)
		snprintf(buf, sizeof(buf), "%02d:%02d.%02d", (int)(t/3600), (int)(t%3600)/60, (int)t%3600%60);
	else
		snprintf(buf, sizeof(buf), "%02d:%02d.%02d", (int)t/3600, (int)(t/60), (int)t%60);
	return buf;
};


void copy() {
	printf("<P><HR><TABLE ALIGN=RIGHT><TR><TD><FONT SIZE=-2>&copy; 1998-2000<BR>Lev M. Walkin<BR><A HREF=mailto:vlm@spelio.net.ru>vlm@spelio.net.ru</A><BR><A HREF=http://www.spelio.net.ru>www.spelio.net.ru</A></TD></TR></TABLE></BODY></HTML>");
};

